# Class JarFileUrlNestedJar

java.lang.Object
org.apache.tomcat.util.scan.AbstractInputStreamJar
org.apache.tomcat.util.scan.JarFileUrlNestedJar

All Implemented Interfaces:
  `AutoCloseable, Jar`

public class JarFileUrlNestedJar extends AbstractInputStreamJar
Implementation of `Jar` that is optimised for file based JAR URLs that refer to a JAR file nested inside a WAR (e.g. URLs of the form jar:file: ... .war!/ ... .jar).

## Constructor Summary

Constructors
Constructor
Description
`JarFileUrlNestedJar(URL url)`

## Method Summary

Modifier and Type
Method
Description
`void`
`close()`
Close any resources associated with this JAR.
`protected NonClosingJarInputStream`
`createJarInputStream()`

### Methods inherited from class AbstractInputStreamJar

`closeStream, exists, getEntryInputStream, getEntryName, getInputStream, getJarFileURL, getLastModified, getManifest, getURL, nextEntry, reset`

### Methods inherited from class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface Jar

`getLastModified`

## Constructor Details

### JarFileUrlNestedJar

public JarFileUrlNestedJar(URL url) throws IOException

Throws:
  `IOException`

## Method Details

### close

public void close()
Description copied from interface: `Jar`
Close any resources associated with this JAR.

### createJarInputStream

protected NonClosingJarInputStream createJarInputStream() throws IOException

Specified by:
  `createJarInputStream` in class `AbstractInputStreamJar`
Throws:
  `IOException`